//******************************************************************
//
//	MMC File Select and Bootloader for "LED Game for AVR"
//
//	2007.2.4	KAWAKAMI Yukio
//	2007.2.8	J[h CS̃|[g PC3ɕύX
//	2007.2.9	t@Cԍhbg̈ʒuŕ\
//	2007.2.15	MMCǂݍ݃[`œKEt@CpJiΉ
//******************************************************************
//	2012.5.10	Mega64pɏC neko Java
//******************************************************************

typedef	unsigned char	uchar;
typedef	unsigned int	uint;
typedef	unsigned long	ulong;
typedef unsigned short	ushort;

struct FDATE {
	unsigned short	ft_day	 : 5;
	unsigned short	ft_month : 4;
	unsigned short	ft_year	 : 7;
};

struct FTIME {
	unsigned short	ft_sec	: 5;
	unsigned short	ft_min	: 6;
	unsigned short	ft_hour	: 5;
};

struct DIRECTORY {
	uchar	filename[8];
	uchar	ext[3];
	uchar	att;
	uchar	not_use[10];
	struct FTIME	time;
	struct FDATE	date;
	unsigned short	cluster;
	ulong	size;
};

struct FILE_DATA {
	ulong	sec;
	uint	sc;
	uint	cluster;
	ushort	size;
	ushort	p;
};

#define		FAT12		1
#define		FAT16		2

#define		ON	1
#define		OFF	0
#define		TRUE	1
#define		FALSE	0

#define		NOP		asm volatile("nop\n"::)
#define		WDR		asm volatile("wdr\n"::)
#define		SLEEP	asm volatile("sleep\n"::)

#define		SW_PORT1	PINE
#define		SW_PORT2	PINB
#define		SW_A	2
#define		SW_B	1
#define		SW_UP	4
#define		SW_DN	7
#define		SW_L	5
#define		SW_R	6

#define		SP_OUT	7		// PORTE

#define LED_COL_PORT1  PORTC	// LEDAm[hp|[g
#define LED_COL_PORT2  PORTA	// LEDAm[hp|[g
#define LED_ROW_PORT1  PORTF	// LEDJ\[hp|[g
#define LED_ROW_PORT2  PORTD	// LEDJ\[hp|[g
#define LED_COL_DDR1   DDRC	 // LEDAm[hp|[go
#define LED_COL_DDR2   DDRA	 // LEDAm[hp|[go
#define LED_ROW_DDR1   DDRF	 // LEDJ\[hp|[go
#define LED_ROW_DDR2   DDRD	 // LEDJ\[hp|[go

#define		MMC_MISO	3	// PORTB
#define		MMC_MOSI	2
#define		MMC_SCK		1

// MMC CSM蓖
#define		MMC_CS_PORT	PORTB
#define		MMC_CS_DDR	DDRB
#define		MMC_CS		0

#define		MMC_CS_ON	MMC_CS_PORT &= ~(1<<MMC_CS)
#define		MMC_CS_OFF	MMC_CS_PORT |= (1<<MMC_CS)


// MakefilẽJIvV̎w
// -Ttext=0x3800,--section-start=.bootsub=0x3000
// ɂA
// ADRS3000H w肵֐ 0x3000`
// ȊO 0x3800`̃u[g̈ɔzu
// ZtvOɕKvȊ֐̓u[g̈ɔzu邱
// ȂAPROGMEMȂǂ̒萔`̓u[g̈ɔzu

#define ADRS3000H	__attribute__ ((section (".bootsub")))


void putcc(uchar x, uchar y, uchar c);
void print(uchar *str);
void cls(void);
void set_dot(uchar x, uchar y);
void LED_send_word(ushort data);
void LED_send_word2(ushort data);

uchar SPI_in(void);
void SPI_out(uchar data);
uchar SPI_command(uchar com, ulong arg);

uchar read_VFAT_info(void);
uchar read_32(ulong addr, uchar *buff);

uchar mmc_read(ulong addr);
uchar mmc_init(void);

ulong cluster_to_adrs(uint cluster);
uint next_cluster(uint c);
uint read_word(ulong addr);

void open_file(struct DIRECTORY *dir, struct FILE_DATA *fd);
void next_sector(struct FILE_DATA *fd);
uchar check_file(struct DIRECTORY *dir);
int search_file(struct DIRECTORY *dir, int max);

int main(void);

void start_game(void);
uchar spm_main(struct FILE_DATA *fd);

