//---------------------------------------------------------------------
//(16x16Dot)LED Game for AVR  by Takuya Matsubara / NICO Corp. 2006
// http://www.nico.to/avr/
//
//   LED\֐
//
// EĔzz͎Rɂł܂B
// Ĕzzꍇɂ͂킩₷`ŖLĂB
// ̕͏C֎~(Please do not delete a document from here.)
//---------------------------------------------------------------------
// 2012.5.10	Mega64pɏC neko Java
//---------------------------------------------------------------------

#include <avr/io.h>
#include "led.h"

#define CAPTURE_SW 0
#if CAPTURE_SW
	#include "sio.h"  // CAPTURE
#endif

unsigned int ledvram[LEDWIDTH];	 // LED Bitmap Buffer
char row=0;

#define LED_COL_PORT1  PORTC	// LEDAm[hp|[g
#define LED_COL_PORT2  PORTA	// LEDAm[hp|[g
#define LED_ROW_PORT1  PORTF	// LEDJ\[hp|[g
#define LED_ROW_PORT2  PORTD	// LEDJ\[hp|[g
#define LED_COL_DDR1   DDRC	 // LEDAm[hp|[go
#define LED_COL_DDR2   DDRA	 // LEDAm[hp|[go
#define LED_ROW_DDR1   DDRF	 // LEDJ\[hp|[go
#define LED_ROW_DDR2   DDRD	 // LEDJ\[hp|[go

//#define LED_CLK   0		// NbNrbgԍ
//#define LED_DATA  2		// f[^rbgԍ
//#define LED_LATCH 1		// b`rbgԍ

#define SYSCLK  8000000UL		// CPU clock 8Mhz
#define TEN_US    400000UL		// 4TCÑ[v10s
#define LOOPCNT   (SYSCLK / TEN_US)	// [vJEg

//EGCg@10 us-----------------------
static void wait_10us( uint8_t t)
{ uint8_t cnt;
  while( t--)
  { for( cnt = 0; cnt<LOOPCNT; cnt++)
     asm volatile("nop");
  }
}
//--------------------------------------

void led_sendword(unsigned int dat);
void led_sendword2(unsigned int dat);
//void led_sendbyte2(unsigned int dat);

//---------------------------------------------------------------------
// LED
// ELEDp|[g܂B
// EVRAM̓e܂B
void led_init(void)
{
	int i;

	/*-------------------------------------------------------------
	LED_DDR |= ((1<<LED_LATCH)|(1<<LED_CLK)|(1<<LED_DATA));	//output
	LED_PORT &= ~(1<<LED_CLK);
	LED_PORT &= ~(1<<LED_LATCH);
	--------------------------------------------------------------*/

	LED_COL_DDR1 = 0xFF; LED_COL_PORT1 = 0;
	LED_COL_DDR2 = 0xFF; LED_COL_PORT2 = 0;
	LED_ROW_DDR1 = 0xFF; LED_ROW_PORT1 = 0;
	LED_ROW_DDR2 = 0xFF; LED_ROW_PORT2 = 0;

	for(i=0;i<LEDWIDTH;i++)
		ledvram[i] = 0x0000;
}

//---------------------------------------------------------------------
// VRAMAhX擾
// EVRAM𒼐ڏƂɎgp
// ߂lFunsigned int ^|C^BVRAM̐擪AhXB
// @@@@VRAM[1s][2s]...[16s]̏16biti[Ă܂B
//gpFunsigned int *p = led_getvram();   // VRAMAhX擾
unsigned int * led_getvram(void)
{
	return(ledvram);
}


//---------------------------------------------------------------------
// LED
// EWbNICׂĂLowo͂āALED܂B
// EX[vOɎg܂B
// EVRAM̓e͏܂B
void led_off(void)
{
	/*----------------------------
	led_sendword(0x0000);
	led_sendword(0x0000);

	LED_PORT |= (1<<LED_LATCH);
	LED_PORT &= ~(1<<LED_LATCH);
	----------------------------*/

	LED_COL_PORT1 = 0; LED_COL_PORT2 = 0;
	LED_ROW_PORT1 = 0; LED_ROW_PORT2 = 0;
}

#if CAPTURE_SW
	unsigned char cap_cnt; //CAPTURE
#endif

//---------------------------------------------------------------------
// LED(32rbgM)
// EVRAMe1s\܂B
// E16Ăяo1ʍXVɑ܂B
// EC[v^C}荞݊֐ɒuAJԂĂяoĂB
void led_disp(void)
{
	unsigned int temp;

	led_sendword(0xFFFF); //Ă
	led_sendword2(ledvram[(int)row]);

	temp = 0x8000 >> row;
	led_sendword(~temp);
//	led_sendbyte2((temp >> 8) ^ 0xff);
//	led_sendbyte2((temp & 0xff) ^ 0xff);

	//LED_PORT |= (1<<LED_LATCH);
	//LED_PORT &= ~(1<<LED_LATCH);

#if CAPTURE_SW
	if(cap_cnt < LEDWIDTH){		  //CAPTURE
		if(cap_cnt==0)	sio_tx('@'); //CAPTURE
		temp = ledvram[(int)row];	//CAPTURE
		sio_tx(temp & 0xFF);		 //CAPTURE
		sio_tx(temp >> 8);		   //CAPTURE
	}								//CAPTURE
	cap_cnt++;					   //CAPTURE
#endif
	row++;
	if(row >= LEDWIDTH)	row=0;

	wait_10us(3);	//\x
	//asm volatile("nop");

}

//---------------------------------------------------------------------
//sNZ`
//xFXWB0`15
//xFYWB0`15
//colorFJ[R[hB0=A1=_iԐFjA2=XOR1
void led_pset(char x,char y,char color)
{
	unsigned int mask;

	if(x<0)return;
	if(y<0)return;
	if(x>15)return;
	if(y>15)return;

	mask=0x8000 >> x;

	if(color==1)
		ledvram[(int)y] |= mask;
	else if(color==0)
		ledvram[(int)y] &= ~mask;
	else if(color==2)
		ledvram[(int)y] ^= mask;

}

//--------------------------------------------------------------------------------
//C`
//x1FX1W
//y1FY1W
//x2FX2W
//y2FY2W
//colorFJ[R[hB0=A1=_iԐFjA2=XOR1
void led_line(char x1 ,char y1 ,char x2 ,char y2 ,char color)
{
	char xd;	// X2-X1W̋
	char yd;	// Y2-Y1W̋
	char xs=1;  // X1pixelړ
	char ys=1;  // Y1pixelړ
	char e;

	xd = x2 - x1;	 // X2-X1W̋
	if(xd < 0){
		xd = -xd;	 // X2-X1W̐Βl
		xs = -1;	  // X1pixelړ
	}
	yd = y2 - y1;	 // Y2-Y1W̋
	if(yd < 0){
		yd = -yd;	 // Y2-Y1W̐Βl
		ys = -1;	  // Y1pixelړ
	}
	led_pset (x1, y1 ,color); //hbg`
	e = 0;
	if( yd < xd ) {
		while( x1 != x2) {
			x1 += xs;
			e += (2 * yd);
			if(e >= xd) {
				y1 += ys;
				e -= (2 * xd);
			}
			led_pset (x1, y1 ,color); //hbg`
		}
	}else{
		while( y1 != y2) {
			y1 += ys;
			e += (2 * xd);
			if(e >= yd) {
				x1 += xs;
				e -= (2 * yd);
			}
			led_pset (x1, y1 ,color); //hbg`
		}
	}
}

//--------------------------------------------------------------------------------
// ʃXN[
// EVRAM̒gIɃVtg܂B
// x1: XړʁB+ƍVtg(_E)A-ƉEVtg(_)
// y1: YړʁB+ƏVtg(_)A-ƉVtg(_)
void led_scroll(char x1,char y1)
{
	int i;
	if(x1!=0){
		if(x1>0){
			for(i=0; i<LEDWIDTH; i++){
				ledvram[i] <<= x1;
			}
		}else{
			for(i=0; i<LEDWIDTH; i++){
				ledvram[i] >>= (-x1);
			}
		}
	}

	if(y1!=0){
		if(y1>0){
			for(i=0; i<LEDWIDTH; i++){
				if((i+y1)>15)
					ledvram[i] = 0;
				else
					ledvram[i] = ledvram[i+y1];
			}
		}else{
			for(i=LEDWIDTH-1; i>=0; i--){
				if((i+y1)<0)
					ledvram[i] = 0;
				else
					ledvram[i] = ledvram[i+y1];
			}
		}
	}
}



//---------------------------------------------------------------------
// ʃrbg16bitM
void led_sendword(unsigned int dat)	//ROW line select
{

	LED_ROW_PORT1 = (unsigned char)(~dat >> 8);
	LED_ROW_PORT2 = (unsigned char)(~dat);

	/*-------------------------------------------
	char bitcnt=16;

	while(bitcnt-- > 0)
	{
		if(dat & 0x8000)
			LED_PORT |=  (1<<LED_DATA);
		else
			LED_PORT &= ~(1<<LED_DATA);

		dat <<= 1;
		LED_PORT |=  (1<<LED_CLK);
		LED_PORT &= ~(1<<LED_CLK);
	}
	--------------------------------------------*/
}

//---------------------------------------------------------------------
// ʃrbg16bitM
void led_sendword2(unsigned int dat)	//COL data
{

	//LED_COL_PORT1 = (unsigned char)(dat >> 8);	//z
	//LED_COL_PORT2 = (unsigned char)(dat);		//ł悢

	//zEt--------------------------
	unsigned int dat2=0, dat3=dat;
	char bitcnt=16;

	while(bitcnt-- > 0)
	{
		dat2 <<= 1;
		if(dat3 & 1) dat2++;
		dat3 >>= 1;
	}
	LED_COL_PORT1 = (unsigned char)(dat >> 8);
	LED_COL_PORT2 = (unsigned char)(dat2 >> 8);

	/*--IWi-------------------------------
	char bitcnt=16;

	while(bitcnt-- > 0)
	{
		if(dat & 1)
			LED_PORT |=  (1<<LED_DATA);
		else
			LED_PORT &= ~(1<<LED_DATA);

		dat >>= 1;
		LED_PORT |=  (1<<LED_CLK);
		LED_PORT &= ~(1<<LED_CLK);
	}
	-------------------------------------------*/
}

//---------------------------------------------------------------------
// ʃrbg8bitM
//void led_sendbyte2(unsigned int dat)
//{
//	char bitcnt=8;
//
//	while(bitcnt-- > 0)
//	{
//		if(dat & 0x1)
//			LED_PORT |=  (1<<LED_DATA);
//		else
//			LED_PORT &= ~(1<<LED_DATA);
//
//		dat >>= 1;
//		LED_PORT |=  (1<<LED_CLK);
//		LED_PORT &= ~(1<<LED_CLK);
//	}
//}
